/*	TOP-SURF: a visual words toolkit
	Copyright (C) 2010 LIACS Media Lab, Leiden University,
	                   Bart Thomee (bthomee@liacs.nl),
					   Erwin M. Bakker (erwin@liacs.nl)	and
					   Michael S. Lew (mlew@liacs.nl).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    See http://www.gnu.org/licenses/gpl.html for the full license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	In addition, this work is covered under the Creative Commons
	Attribution license version 3.
    See http://creativecommons.org/licenses/by/3.0/ for the full license.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace MediaLab.TopSurf
{
	// allow easy thread-safe access to control manipulation of a form
	public static class ControlHelper
	{
		public static void SyncInvoke(Control control, MethodInvoker del)
		{
			if ((control != null) && control.InvokeRequired)
				control.Invoke(del, null);
			else
				del();
		}

		public static void AsyncInvoke(Control control, MethodInvoker del)
		{
			if ((control != null) && control.InvokeRequired)
				control.BeginInvoke(del, null);
			else
				del();
		}
	}
}
