﻿/*	TOP-SURF: a visual words toolkit
	Copyright (C) 2010 LIACS Media Lab, Leiden University,
	                   Bart Thomee (bthomee@liacs.nl),
					   Erwin M. Bakker (erwin@liacs.nl)	and
					   Michael S. Lew (mlew@liacs.nl).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    See http://www.gnu.org/licenses/gpl.html for the full license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	In addition, this work is covered under the Creative Commons
	Attribution license version 3.
    See http://creativecommons.org/licenses/by/3.0/ for the full license.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace MediaLab.TopSurf
{
	public partial class CreateDictionaryForm : Form
	{
		public string ImageDirectory { get { return directoryBox.Text; } }
		public int Clusters { get { return (int)clustersUpDown.Value; } }
		public int KNN { get { return (int)knnUpDown.Value; } }
		public int Iterations { get { return (int)iterationsUpDown.Value; } }
		public int Points { get { return (int)pointsUpDown.Value; } }

		public CreateDictionaryForm()
		{
			InitializeComponent();
			// set the initial directory
			directoryBox.Text = Directory.GetCurrentDirectory();
		}

		private void browseButton_Click(object sender, EventArgs e)
		{
			using (FolderBrowserDialog fbd = new FolderBrowserDialog())
			{
				fbd.Description = "Please choose directory that contains images.";
				fbd.SelectedPath = Directory.GetCurrentDirectory();
				fbd.ShowNewFolderButton = false;
				if (fbd.ShowDialog() != DialogResult.OK)
					return;
				directoryBox.Text = fbd.SelectedPath;
			}
		}

		private void directoryBox_Enter(object sender, EventArgs e)
		{
			directoryBox.SelectAll();
		}

		private void clustersUpDown_Enter(object sender, EventArgs e)
		{
			clustersUpDown.Select(0, clustersUpDown.Value.ToString().Length);
		}

		private void knnUpDown_Enter(object sender, EventArgs e)
		{
			knnUpDown.Select(0, knnUpDown.Value.ToString().Length);
		}

		private void iterationsUpDown_Enter(object sender, EventArgs e)
		{
			iterationsUpDown.Select(0, iterationsUpDown.Value.ToString().Length);
		}

		private void pointsUpDown_Enter(object sender, EventArgs e)
		{
			pointsUpDown.Select(0, pointsUpDown.Value.ToString().Length);
		}
	}
}
