/*	TOP-SURF: a visual words toolkit
	Copyright (C) 2010 LIACS Media Lab, Leiden University,
	                   Bart Thomee (bthomee@liacs.nl),
					   Erwin M. Bakker (erwin@liacs.nl)	and
					   Michael S. Lew (mlew@liacs.nl).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    See http://www.gnu.org/licenses/gpl.html for the full license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	In addition, this work is covered under the Creative Commons
	Attribution license version 3.
    See http://creativecommons.org/licenses/by/3.0/ for the full license.
*/

using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace MediaLab.TopSurf
{
	// some handy image-related functionality
	public static class ImageHelper
	{
		public static bool IsImage(string path)
		{
			string extension = Path.GetExtension(path);
			if (extension.Equals(".jpg", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".jpeg", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".png", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".tif", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".tiff", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".gif", StringComparison.CurrentCultureIgnoreCase) ||
				extension.Equals(".bmp", StringComparison.CurrentCultureIgnoreCase))
				return true;
			return false;
		}
	}
}
