﻿/*	TOP-SURF: a visual words toolkit
	Copyright (C) 2010 LIACS Media Lab, Leiden University,
	                   Bart Thomee (bthomee@liacs.nl),
					   Erwin M. Bakker (erwin@liacs.nl)	and
					   Michael S. Lew (mlew@liacs.nl).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    See http://www.gnu.org/licenses/gpl.html for the full license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	In addition, this work is covered under the Creative Commons
	Attribution license version 3.
    See http://creativecommons.org/licenses/by/3.0/ for the full license.
*/

using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;

namespace MediaLab.TopSurf
{
	public class TOPSURF_DISTANCE : IComparable<TOPSURF_DISTANCE>
	{
		Bitmap m_image1;
		public Bitmap Image1 { get { return m_image1; } }
		Bitmap m_image2;
		public Bitmap Image2 { get { return m_image2; } }
		float m_distance;
		public float Distance { get { return m_distance; } }

		public TOPSURF_DISTANCE(Bitmap image1, Bitmap image2, float distance)
		{
			// copy the bitmap pointers, so we don't need to do
			// any expensive copying. we can do this because we
			// only hold them temporarily while both source
			// bitmaps are guaranteed to be valid
			m_image1 = image1;
			m_image2 = image2;
			m_distance = distance;
		}

		public int CompareTo(TOPSURF_DISTANCE td)
		{
			return Distance.CompareTo(td.Distance);
		}
	}
}
